package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.recovery.RcvSysUser;
import com.docus.server.infrastructure.dao.IRcvSysUserDao;
import com.docus.server.infrastructure.mapper.RcvSysUserMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import java.util.List;

/**
 * 系统登录用户表 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-09-13
 */
@Repository
public class RcvSysUserDaoImpl extends BaseDaoImpl<RcvSysUserMapper, RcvSysUser> implements IRcvSysUserDao {


    /**
     * 新增
     *
     * @param rcvSysUser 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(RcvSysUser rcvSysUser) {
        return super.save(rcvSysUser);
    }

    /**
     * 编辑
     *
     * @param rcvSysUser 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(RcvSysUser rcvSysUser) {
        return super.updateById(rcvSysUser);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(Collection<? extends Serializable> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<RcvSysUser> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<RcvSysUser> query = Wrappers.lambdaQuery();
        //时间范围，默认按createTime
        if (searchDTO.getBeginTime() != null) {
            query.ge(RcvSysUser::getCreateTime, searchDTO.getBeginTime());
        }
        if (searchDTO.getEndTime() != null) {
            Date endTime = searchDTO.getEndTime();
            query.le(RcvSysUser::getCreateTime, endTime);
        }
        //关键字比较，多个列or
        //if (!StringUtils.isEmpty(searchDTO.getKeyword())) {
        //单个列用like
        //query. like(RcvSysUser::getxxx, searchDTO.getKeyword());
        //多个列用like
        //query. and(sub -> sub.like(RcvSysUser::getxx1, searchDTO.getKeyword())
        // оr(). like(RcvSysUser::getXX2, searchDTO.getKeyword()))
        //);
        //}
        //默认createTime倒序排序
        query.orderByDesc(RcvSysUser::getCreateTime);
        List<RcvSysUser> list = super.find(query);
        return new PageResult<>(list);
    }

    /**
     * 名称不重复
     *
     * @param id   主键
     * @param name 名称
     * @return 名称重复数量
     */
    @Override
    public int findByIdAndName(Serializable id, String name) {
        LambdaQueryWrapper<RcvSysUser> query = Wrappers.lambdaQuery();
        if (id != null) {
            query.ne(RcvSysUser::getUserId, id);
        }
        //if (Func.isNotBlank(name)) {
        //   query.eq(RcvSysUser::getName, name);
        //}

        return baseMapper.selectCount(query);
    }
}
